/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 497
#ifdef HAVE_CONFIG_H
#line 497
# include <config.h>
#line 497
#endif
#line 497
#include <sys/types.h>
#line 497

#line 497
#include "mailfromd.h"
#line 497
#include "prog.h"
#line 497
#include "builtin.h"
#line 497

#line 497

#line 742 "../../src/builtin/snarf.m4"

#line 1 "msg.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"
#include "global.h"

static size_t nmsgs = MAX_MSGS;

static struct mu_cfg_param msg_cfg_param[] = {
	{ "max-open-messages", mu_cfg_size, &nmsgs, 0, NULL,
	  N_("Maximum number of messages to open simultaneously.") },
	{ NULL }
};

static void *
alloc_msgs()
{
	return xcalloc(nmsgs, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + nmsgs; p++) {
		bi_close_message(p);
	}
	free(mtab);
}

void
drop_current_message(void *data)
{
	int i;
	struct mf_message *tab = data;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].current) {
			bi_close_message(&tab[i]);
			break;
		}
}


#line 57

#line 57
static int MSGTAB_id;
#line 57 "msg.bi"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		mu_stream_destroy(&mp->mstr);
		mu_stream_destroy(&mp->bstr);
		if (mp->mylist) {
			mu_list_remove(mp->mylist, mp);
			mu_list_destroy(&mp->mylist);
		}
		mu_list_do(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int current)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->current = current;
		mu_list_create(&mp->mylist);
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].current)
			return i;
	return -1;
}


#line 134


#line 145


#line 156


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 161
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 161
	struct mf_message *mp;
#line 161
			
#line 161
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 161
		(
#line 161
	env_throw_bi(env, mfe_range, NULL, _("invalid message descriptor"))
#line 161
)
#line 161
;
#line 161
	mp = mtab + nmsg;
#line 161
		if (!(mp->msg))
#line 161
		(
#line 161
	env_throw_bi(env, mfe_failure, NULL, _("message not open"))
#line 161
)
#line 161

#line 161
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 166
bi_message_close(eval_environ_t env)
#line 166

#line 166

#line 166 "msg.bi"
{
#line 166
	
#line 166

#line 166

#line 166
long  nmsg;
#line 166
        
#line 166
get_numeric_arg(env, 0, &nmsg);
#line 166
        
#line 166

#line 166
        adjust_stack(env, 1);
#line 166

#line 166

#line 166
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 166
		prog_trace(env, "message_close %lu",nmsg);;
#line 166

{
	
#line 168
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 168
	struct mf_message *mp;
#line 168
			
#line 168
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 168
		(
#line 168
	env_throw_bi(env, mfe_range, "message_close", _("invalid message descriptor"))
#line 168
)
#line 168
;
#line 168
	mp = mtab + nmsg;
#line 168
		if (!(mp->msg))
#line 168
		(
#line 168
	env_throw_bi(env, mfe_failure, "message_close", _("message not open"))
#line 168
)
#line 168

#line 168
;
	bi_close_message(mp);
}

#line 171
	return;
#line 171
}

/* number message_size(number nmsg) */
void
#line 174
bi_message_size(eval_environ_t env)
#line 174

#line 174

#line 174 "msg.bi"
{
#line 174
	
#line 174

#line 174

#line 174
long  nmsg;
#line 174
        
#line 174
get_numeric_arg(env, 0, &nmsg);
#line 174
        
#line 174

#line 174
        adjust_stack(env, 1);
#line 174

#line 174

#line 174
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 174
		prog_trace(env, "message_size %lu",nmsg);;
#line 174

{
	int rc;
	size_t size;
	
#line 178
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 178
	struct mf_message *mp;
#line 178
			
#line 178
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 178
		(
#line 178
	env_throw_bi(env, mfe_range, "message_size", _("invalid message descriptor"))
#line 178
)
#line 178
;
#line 178
	mp = mtab + nmsg;
#line 178
		if (!(mp->msg))
#line 178
		(
#line 178
	env_throw_bi(env, mfe_failure, "message_size", _("message not open"))
#line 178
)
#line 178

#line 178
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 181
		(
#line 181
	env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 181
)
#line 183
;
		if (!(size < LONG_MAX))
#line 184
		(
#line 184
	env_throw_bi(env, mfe_range, "message_size", _("message size out of representable range"))
#line 184
)
#line 186
;
	
#line 187
do {
#line 187
  push(env, (STKVAL) ((long)size));
#line 187
  goto endlab;
#line 187
} while (0);
}	
endlab:
#line 189
	return;
#line 189
}

/* number message_lines(number nmsg) */
void
#line 192
bi_message_lines(eval_environ_t env)
#line 192

#line 192

#line 192 "msg.bi"
{
#line 192
	
#line 192

#line 192

#line 192
long  nmsg;
#line 192
        
#line 192
get_numeric_arg(env, 0, &nmsg);
#line 192
        
#line 192

#line 192
        adjust_stack(env, 1);
#line 192

#line 192

#line 192
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 192
		prog_trace(env, "message_lines %lu",nmsg);;
#line 192

{
	int rc;
	size_t lines;
	
#line 196
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 196
	struct mf_message *mp;
#line 196
			
#line 196
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 196
		(
#line 196
	env_throw_bi(env, mfe_range, "message_lines", _("invalid message descriptor"))
#line 196
)
#line 196
;
#line 196
	mp = mtab + nmsg;
#line 196
		if (!(mp->msg))
#line 196
		(
#line 196
	env_throw_bi(env, mfe_failure, "message_lines", _("message not open"))
#line 196
)
#line 196

#line 196
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 199
		(
#line 199
	env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 199
)
#line 202
;
	
#line 203
do {
#line 203
  push(env, (STKVAL) (lines));
#line 203
  goto endlab;
#line 203
} while (0);
}
endlab:
#line 205
	return;
#line 205
}

/* number message_body_size(number nmsg) */
void
#line 208
bi_message_body_size(eval_environ_t env)
#line 208

#line 208

#line 208 "msg.bi"
{
#line 208
	
#line 208

#line 208

#line 208
long  nmsg;
#line 208
        
#line 208
get_numeric_arg(env, 0, &nmsg);
#line 208
        
#line 208

#line 208
        adjust_stack(env, 1);
#line 208

#line 208

#line 208
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 208
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 208

{
	int rc;
	size_t size;
	
#line 212
	
#line 212
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 212
	struct mf_message *mp;
#line 212
			
#line 212
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 212
		(
#line 212
	env_throw_bi(env, mfe_range, "message_body_size", _("invalid message descriptor"))
#line 212
)
#line 212
;
#line 212
	mp = mtab + nmsg;
#line 212
		if (!(mp->msg))
#line 212
		(
#line 212
	env_throw_bi(env, mfe_failure, "message_body_size", _("message not open"))
#line 212
)
#line 212

#line 212
;
#line 212
	if (!mp->body) {
#line 212
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 212
			if (!(rc == 0))
#line 212
		(
#line 212
	env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 212
)
#line 212
;
#line 212
	}	  
#line 212
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 215
		(
#line 215
	env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 215
)
#line 217
;
		if (!(size < LONG_MAX))
#line 218
		(
#line 218
	env_throw_bi(env, mfe_range, "message_body_size", _("body size out of representable range"))
#line 218
)
#line 220
;
	
#line 221
do {
#line 221
  push(env, (STKVAL) ((long)size));
#line 221
  goto endlab;
#line 221
} while (0);
}
endlab:
#line 223
	return;
#line 223
}

/* number message_body_lines(number nmsg) */
void
#line 226
bi_message_body_lines(eval_environ_t env)
#line 226

#line 226

#line 226 "msg.bi"
{
#line 226
	
#line 226

#line 226

#line 226
long  nmsg;
#line 226
        
#line 226
get_numeric_arg(env, 0, &nmsg);
#line 226
        
#line 226

#line 226
        adjust_stack(env, 1);
#line 226

#line 226

#line 226
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 226
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 226

{
	int rc;
	size_t lines;
	
#line 230
	
#line 230
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 230
	struct mf_message *mp;
#line 230
			
#line 230
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 230
		(
#line 230
	env_throw_bi(env, mfe_range, "message_body_lines", _("invalid message descriptor"))
#line 230
)
#line 230
;
#line 230
	mp = mtab + nmsg;
#line 230
		if (!(mp->msg))
#line 230
		(
#line 230
	env_throw_bi(env, mfe_failure, "message_body_lines", _("message not open"))
#line 230
)
#line 230

#line 230
;
#line 230
	if (!mp->body) {
#line 230
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 230
			if (!(rc == 0))
#line 230
		(
#line 230
	env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 230
)
#line 230
;
#line 230
	}	  
#line 230
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 233
		(
#line 233
	env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 233
)
#line 236
;
	
#line 237
do {
#line 237
  push(env, (STKVAL) (lines));
#line 237
  goto endlab;
#line 237
} while (0);
}
endlab:
#line 239
	return;
#line 239
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 245
bi_message_header_size(eval_environ_t env)
#line 245

#line 245

#line 245 "msg.bi"
{
#line 245
	
#line 245

#line 245

#line 245
long  nmsg;
#line 245
        
#line 245
get_numeric_arg(env, 0, &nmsg);
#line 245
        
#line 245

#line 245
        adjust_stack(env, 1);
#line 245

#line 245

#line 245
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 245
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 245

{
	int rc;
	size_t size;
	
#line 249
	
#line 249
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 249
	struct mf_message *mp;
#line 249
			
#line 249
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 249
		(
#line 249
	env_throw_bi(env, mfe_range, "message_header_size", _("invalid message descriptor"))
#line 249
)
#line 249
;
#line 249
	mp = mtab + nmsg;
#line 249
		if (!(mp->msg))
#line 249
		(
#line 249
	env_throw_bi(env, mfe_failure, "message_header_size", _("message not open"))
#line 249
)
#line 249

#line 249
;
#line 249
	if (!mp->hdr) {
#line 249
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 249
			if (!(rc == 0))
#line 249
		(
#line 249
	env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 249
)
#line 249
;
#line 249
	}	  
#line 249
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 252
		(
#line 252
	env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 252
)
#line 254
;
		if (!(size < LONG_MAX))
#line 255
		(
#line 255
	env_throw_bi(env, mfe_range, "message_header_size", _("header size out of representable range"))
#line 255
)
#line 257
;
	
#line 258
do {
#line 258
  push(env, (STKVAL) ((long)size));
#line 258
  goto endlab;
#line 258
} while (0);
}
endlab:
#line 260
	return;
#line 260
}

/* number message_header_lines(number nmsg) */
void
#line 263
bi_message_header_lines(eval_environ_t env)
#line 263

#line 263

#line 263 "msg.bi"
{
#line 263
	
#line 263

#line 263

#line 263
long  nmsg;
#line 263
        
#line 263
get_numeric_arg(env, 0, &nmsg);
#line 263
        
#line 263

#line 263
        adjust_stack(env, 1);
#line 263

#line 263

#line 263
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 263
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 263

{
	int rc;
	size_t lines;
	
#line 267
	
#line 267
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 267
	struct mf_message *mp;
#line 267
			
#line 267
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 267
		(
#line 267
	env_throw_bi(env, mfe_range, "message_header_lines", _("invalid message descriptor"))
#line 267
)
#line 267
;
#line 267
	mp = mtab + nmsg;
#line 267
		if (!(mp->msg))
#line 267
		(
#line 267
	env_throw_bi(env, mfe_failure, "message_header_lines", _("message not open"))
#line 267
)
#line 267

#line 267
;
#line 267
	if (!mp->hdr) {
#line 267
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 267
			if (!(rc == 0))
#line 267
		(
#line 267
	env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 267
)
#line 267
;
#line 267
	}	  
#line 267
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 270
		(
#line 270
	env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 270
)
#line 273
;
	
#line 274
do {
#line 274
  push(env, (STKVAL) (lines));
#line 274
  goto endlab;
#line 274
} while (0);
}
endlab:
#line 276
	return;
#line 276
}

/* number message_header_count(number nmsg[; string name]) */
void
#line 279
bi_message_header_count(eval_environ_t env)
#line 279

#line 279

#line 279 "msg.bi"
{
#line 279
	
#line 279

#line 279
long __bi_argcnt;
#line 279
long  nmsg;
#line 279
        char *  name;
#line 279
        
#line 279
get_numeric_arg(env, 1, &nmsg);
#line 279
        get_string_arg(env, 2, &name);
#line 279
        
#line 279
get_numeric_arg(env, 0, &__bi_argcnt);
#line 279
        adjust_stack(env, __bi_argcnt + 1);
#line 279

#line 279

#line 279
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 279
		prog_trace(env, "message_header_count %lu %s",nmsg, ((__bi_argcnt > 1) ? name : ""));;

{
	int rc;
	size_t count;
	
#line 284
	
#line 284
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 284
	struct mf_message *mp;
#line 284
			
#line 284
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 284
		(
#line 284
	env_throw_bi(env, mfe_range, "message_header_count", _("invalid message descriptor"))
#line 284
)
#line 284
;
#line 284
	mp = mtab + nmsg;
#line 284
		if (!(mp->msg))
#line 284
		(
#line 284
	env_throw_bi(env, mfe_failure, "message_header_count", _("message not open"))
#line 284
)
#line 284

#line 284
;
#line 284
	if (!mp->hdr) {
#line 284
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 284
			if (!(rc == 0))
#line 284
		(
#line 284
	env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 284
)
#line 284
;
#line 284
	}	  
#line 284
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 287
		(
#line 287
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 287
)
#line 290
;
	
	if ((__bi_argcnt > 1)) {
		size_t n;

		for (n = 1; n <= count; n++) {
			const char *val;
			rc = mu_header_sget_value_n(mp->hdr, name, n, &val);
			if (rc == MU_ERR_NOENT)
				break;
			else if (rc)
				(
#line 301
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 301
);
		}
		count = n - 1;
	}
	
#line 305
do {
#line 305
  push(env, (STKVAL) (count));
#line 305
  goto endlab;
#line 305
} while (0);
}
endlab:
#line 307
	return;
#line 307
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 310
bi_message_has_header(eval_environ_t env)
#line 310

#line 310

#line 310 "msg.bi"
{
#line 310
	
#line 310

#line 310
long __bi_argcnt;
#line 310
long  nmsg;
#line 310
        char *  header;
#line 310
        long  idx;
#line 310
        
#line 310
get_numeric_arg(env, 1, &nmsg);
#line 310
        get_string_arg(env, 2, &header);
#line 310
        get_numeric_arg(env, 3, &idx);
#line 310
        
#line 310
get_numeric_arg(env, 0, &__bi_argcnt);
#line 310
        adjust_stack(env, __bi_argcnt + 1);
#line 310

#line 310

#line 310
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 310
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 315
	
#line 315
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 315
	struct mf_message *mp;
#line 315
			
#line 315
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 315
		(
#line 315
	env_throw_bi(env, mfe_range, "message_has_header", _("invalid message descriptor"))
#line 315
)
#line 315
;
#line 315
	mp = mtab + nmsg;
#line 315
		if (!(mp->msg))
#line 315
		(
#line 315
	env_throw_bi(env, mfe_failure, "message_has_header", _("message not open"))
#line 315
)
#line 315

#line 315
;
#line 315
	if (!mp->hdr) {
#line 315
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 315
			if (!(rc == 0))
#line 315
		(
#line 315
	env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 315
)
#line 315
;
#line 315
	}	  
#line 315
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 318
do {
#line 318
  push(env, (STKVAL) (rc == 0));
#line 318
  goto endlab;
#line 318
} while (0);
}
endlab:
#line 320
	return;
#line 320
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 323
bi_message_find_header(eval_environ_t env)
#line 323

#line 323

#line 323 "msg.bi"
{
#line 323
	
#line 323

#line 323
long __bi_argcnt;
#line 323
long  nmsg;
#line 323
        char * MFL_DATASEG header;
#line 323
        long  idx;
#line 323
        
#line 323
get_numeric_arg(env, 1, &nmsg);
#line 323
        get_string_arg(env, 2, &header);
#line 323
        get_numeric_arg(env, 3, &idx);
#line 323
        
#line 323
get_numeric_arg(env, 0, &__bi_argcnt);
#line 323
        adjust_stack(env, __bi_argcnt + 1);
#line 323

#line 323

#line 323
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 323
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 328
	
#line 328
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 328
	struct mf_message *mp;
#line 328
			
#line 328
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 328
		(
#line 328
	env_throw_bi(env, mfe_range, "message_find_header", _("invalid message descriptor"))
#line 328
)
#line 328
;
#line 328
	mp = mtab + nmsg;
#line 328
		if (!(mp->msg))
#line 328
		(
#line 328
	env_throw_bi(env, mfe_failure, "message_find_header", _("message not open"))
#line 328
)
#line 328

#line 328
;
#line 328
	if (!mp->hdr) {
#line 328
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 328
			if (!(rc == 0))
#line 328
		(
#line 328
	env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 328
)
#line 328
;
#line 328
	}	  
#line 328
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
		(
#line 332
	env_throw_bi(env, mfe_not_found, "message_find_header", _("header not found"))
#line 332
);
	else if (rc)
		(
#line 334
	env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc))
#line 334
);
	do {pushs(env, val);
#line 335
goto endlab;
#line 335
} while (0);
}
endlab:
#line 337
	return;
#line 337
}

/* string message_nth_header_name(number msg, number n) */
void
#line 340
bi_message_nth_header_name(eval_environ_t env)
#line 340

#line 340

#line 340 "msg.bi"
{
#line 340
	
#line 340

#line 340

#line 340
long  nmsg;
#line 340
        long  idx;
#line 340
        
#line 340
get_numeric_arg(env, 0, &nmsg);
#line 340
        get_numeric_arg(env, 1, &idx);
#line 340
        
#line 340

#line 340
        adjust_stack(env, 2);
#line 340

#line 340

#line 340
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 340
		prog_trace(env, "message_nth_header_name %lu %lu",nmsg, idx);;
#line 340

{
	int rc;
	const char *val;
	
#line 344
	
#line 344
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 344
	struct mf_message *mp;
#line 344
			
#line 344
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 344
		(
#line 344
	env_throw_bi(env, mfe_range, "message_nth_header_name", _("invalid message descriptor"))
#line 344
)
#line 344
;
#line 344
	mp = mtab + nmsg;
#line 344
		if (!(mp->msg))
#line 344
		(
#line 344
	env_throw_bi(env, mfe_failure, "message_nth_header_name", _("message not open"))
#line 344
)
#line 344

#line 344
;
#line 344
	if (!mp->hdr) {
#line 344
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 344
			if (!(rc == 0))
#line 344
		(
#line 344
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "mu_message_get_header: %s",mu_strerror(rc))
#line 344
)
#line 344
;
#line 344
	}	  
#line 344
;
	
	rc = mu_header_sget_field_name(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 348
	env_throw_bi(env, mfe_range, "message_nth_header_name", "header index out of range")
#line 348
);
	else if (rc)
		(
#line 350
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "%s",mu_strerror(rc))
#line 350
);
	do {pushs(env, val);
#line 351
goto endlab;
#line 351
} while (0);
}
endlab:
#line 353
	return;
#line 353
}

/* string message_nth_header_value(number msg, number n) */
void
#line 356
bi_message_nth_header_value(eval_environ_t env)
#line 356

#line 356

#line 356 "msg.bi"
{
#line 356
	
#line 356

#line 356

#line 356
long  nmsg;
#line 356
        long  idx;
#line 356
        
#line 356
get_numeric_arg(env, 0, &nmsg);
#line 356
        get_numeric_arg(env, 1, &idx);
#line 356
        
#line 356

#line 356
        adjust_stack(env, 2);
#line 356

#line 356

#line 356
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 356
		prog_trace(env, "message_nth_header_value %lu %lu",nmsg, idx);;
#line 356

{
	int rc;
	const char *val;
	
#line 360
	
#line 360
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 360
	struct mf_message *mp;
#line 360
			
#line 360
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 360
		(
#line 360
	env_throw_bi(env, mfe_range, "message_nth_header_value", _("invalid message descriptor"))
#line 360
)
#line 360
;
#line 360
	mp = mtab + nmsg;
#line 360
		if (!(mp->msg))
#line 360
		(
#line 360
	env_throw_bi(env, mfe_failure, "message_nth_header_value", _("message not open"))
#line 360
)
#line 360

#line 360
;
#line 360
	if (!mp->hdr) {
#line 360
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 360
			if (!(rc == 0))
#line 360
		(
#line 360
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "mu_message_get_header: %s",mu_strerror(rc))
#line 360
)
#line 360
;
#line 360
	}	  
#line 360
;
	
	rc = mu_header_sget_field_value(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 364
	env_throw_bi(env, mfe_range, "message_nth_header_value", "header index out of range")
#line 364
);
	else if (rc)
		(
#line 366
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "%s",mu_strerror(rc))
#line 366
);
	do {pushs(env, val);
#line 367
goto endlab;
#line 367
} while (0);
}
endlab:
#line 369
	return;
#line 369
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 375
bi_message_is_multipart(eval_environ_t env)
#line 375

#line 375

#line 375 "msg.bi"
{
#line 375
	
#line 375

#line 375

#line 375
long  nmsg;
#line 375
        
#line 375
get_numeric_arg(env, 0, &nmsg);
#line 375
        
#line 375

#line 375
        adjust_stack(env, 1);
#line 375

#line 375

#line 375
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 375
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 375

{
	int rc, res;
	
#line 378
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 378
	struct mf_message *mp;
#line 378
			
#line 378
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 378
		(
#line 378
	env_throw_bi(env, mfe_range, "message_is_multipart", _("invalid message descriptor"))
#line 378
)
#line 378
;
#line 378
	mp = mtab + nmsg;
#line 378
		if (!(mp->msg))
#line 378
		(
#line 378
	env_throw_bi(env, mfe_failure, "message_is_multipart", _("message not open"))
#line 378
)
#line 378

#line 378
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 381
		(
#line 381
	env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 381
)
#line 384
;
	
#line 385
do {
#line 385
  push(env, (STKVAL) (res));
#line 385
  goto endlab;
#line 385
} while (0);
}
endlab:
#line 387
	return;
#line 387
}

/* number message_count_parts(number msg) */
void
#line 390
bi_message_count_parts(eval_environ_t env)
#line 390

#line 390

#line 390 "msg.bi"
{
#line 390
	
#line 390

#line 390

#line 390
long  nmsg;
#line 390
        
#line 390
get_numeric_arg(env, 0, &nmsg);
#line 390
        
#line 390

#line 390
        adjust_stack(env, 1);
#line 390

#line 390

#line 390
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 390
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 390

{
	int rc;
	size_t count;
	
#line 394
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 394
	struct mf_message *mp;
#line 394
			
#line 394
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 394
		(
#line 394
	env_throw_bi(env, mfe_range, "message_count_parts", _("invalid message descriptor"))
#line 394
)
#line 394
;
#line 394
	mp = mtab + nmsg;
#line 394
		if (!(mp->msg))
#line 394
		(
#line 394
	env_throw_bi(env, mfe_failure, "message_count_parts", _("message not open"))
#line 394
)
#line 394

#line 394
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 396
		(
#line 396
	env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 396
)
#line 399
;
	
#line 400
do {
#line 400
  push(env, (STKVAL) (count));
#line 400
  goto endlab;
#line 400
} while (0);
}
endlab:
#line 402
	return;
#line 402
}

/* number message_get_part(number msg, number idx) */
void
#line 405
bi_message_get_part(eval_environ_t env)
#line 405

#line 405

#line 405 "msg.bi"
{
#line 405
	
#line 405

#line 405

#line 405
long  nmsg;
#line 405
        long  idx;
#line 405
        
#line 405
get_numeric_arg(env, 0, &nmsg);
#line 405
        get_numeric_arg(env, 1, &idx);
#line 405
        
#line 405

#line 405
        adjust_stack(env, 2);
#line 405

#line 405

#line 405
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 405
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 405

{
	int rc;
	mu_message_t msg;
	
#line 409
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 409
	struct mf_message *mp;
#line 409
			
#line 409
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 409
		(
#line 409
	env_throw_bi(env, mfe_range, "message_get_part", _("invalid message descriptor"))
#line 409
)
#line 409
;
#line 409
	mp = mtab + nmsg;
#line 409
		if (!(mp->msg))
#line 409
		(
#line 409
	env_throw_bi(env, mfe_failure, "message_get_part", _("message not open"))
#line 409
)
#line 409

#line 409
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 412
		(
#line 412
	env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 412
)
#line 415
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 417
		(
#line 417
	env_throw_bi(env, mfe_failure, "message_get_part", _("no more message slots available"))
#line 417
)
#line 419
;
	
#line 420
do {
#line 420
  push(env, (STKVAL) (rc));
#line 420
  goto endlab;
#line 420
} while (0);
}
endlab:
#line 422
	return;
#line 422
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 428
bi_message_rewind(eval_environ_t env)
#line 428

#line 428

#line 428 "msg.bi"
{
#line 428
	
#line 428

#line 428

#line 428
long  nmsg;
#line 428
        
#line 428
get_numeric_arg(env, 0, &nmsg);
#line 428
        
#line 428

#line 428
        adjust_stack(env, 1);
#line 428

#line 428

#line 428
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 428
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 428

{
	
#line 430
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 430
	struct mf_message *mp;
#line 430
			
#line 430
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 430
		(
#line 430
	env_throw_bi(env, mfe_range, "message_rewind", _("invalid message descriptor"))
#line 430
)
#line 430
;
#line 430
	mp = mtab + nmsg;
#line 430
		if (!(mp->msg))
#line 430
		(
#line 430
	env_throw_bi(env, mfe_failure, "message_rewind", _("message not open"))
#line 430
)
#line 430

#line 430
;
	mu_stream_destroy(&mp->mstr);
}

#line 433
	return;
#line 433
}

/* string message_read_line(number nmsg) */
void
#line 436
bi_message_read_line(eval_environ_t env)
#line 436

#line 436

#line 436 "msg.bi"
{
#line 436
	
#line 436

#line 436

#line 436
long  nmsg;
#line 436
        
#line 436
get_numeric_arg(env, 0, &nmsg);
#line 436
        
#line 436

#line 436
        adjust_stack(env, 1);
#line 436

#line 436

#line 436
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 436
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 436

{
	int rc;
	size_t size;
	
#line 440
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 440
	struct mf_message *mp;
#line 440
			
#line 440
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 440
		(
#line 440
	env_throw_bi(env, mfe_range, "message_read_line", _("invalid message descriptor"))
#line 440
)
#line 440
;
#line 440
	mp = mtab + nmsg;
#line 440
		if (!(mp->msg))
#line 440
		(
#line 440
	env_throw_bi(env, mfe_failure, "message_read_line", _("message not open"))
#line 440
)
#line 440

#line 440
;

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 444
		(
#line 444
	env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 444
)
#line 447
;
	}
	rc = mu_stream_getline(mp->mstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 450
		(
#line 450
	env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 450
)
#line 453
;
		if (!(size > 0))
#line 454
		(
#line 454
	env_throw_bi(env, mfe_eof, "message_read_line", "mu_stream_getline: %s",_("end of input"))
#line 454
)
#line 457
;
	do {pushs(env, mp->buf);
#line 458
goto endlab;
#line 458
} while (0);
}
endlab:
#line 460
	return;
#line 460
}

/* string message_body_rewind(number nmsg) */
void
#line 463
bi_message_body_rewind(eval_environ_t env)
#line 463

#line 463

#line 463 "msg.bi"
{
#line 463
	
#line 463

#line 463

#line 463
long  nmsg;
#line 463
        
#line 463
get_numeric_arg(env, 0, &nmsg);
#line 463
        
#line 463

#line 463
        adjust_stack(env, 1);
#line 463

#line 463

#line 463
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 463
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 463

{
	
#line 465
	
#line 465
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 465
	struct mf_message *mp;
#line 465
			
#line 465
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 465
		(
#line 465
	env_throw_bi(env, mfe_range, "message_body_rewind", _("invalid message descriptor"))
#line 465
)
#line 465
;
#line 465
	mp = mtab + nmsg;
#line 465
		if (!(mp->msg))
#line 465
		(
#line 465
	env_throw_bi(env, mfe_failure, "message_body_rewind", _("message not open"))
#line 465
)
#line 465

#line 465
;
#line 465
	if (!mp->body) {
#line 465
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 465
			if (!(rc == 0))
#line 465
		(
#line 465
	env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 465
)
#line 465
;
#line 465
	}	  
#line 465
;
	mu_stream_destroy(&mp->bstr);
}

#line 468
	return;
#line 468
}

/* string message_read_body_line(number msg)  */
void
#line 471
bi_message_read_body_line(eval_environ_t env)
#line 471

#line 471

#line 471 "msg.bi"
{
#line 471
	
#line 471

#line 471

#line 471
long  nmsg;
#line 471
        
#line 471
get_numeric_arg(env, 0, &nmsg);
#line 471
        
#line 471

#line 471
        adjust_stack(env, 1);
#line 471

#line 471

#line 471
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 471
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 471

{
	int rc;
	size_t size;
	
#line 475
	
#line 475
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 475
	struct mf_message *mp;
#line 475
			
#line 475
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 475
		(
#line 475
	env_throw_bi(env, mfe_range, "message_read_body_line", _("invalid message descriptor"))
#line 475
)
#line 475
;
#line 475
	mp = mtab + nmsg;
#line 475
		if (!(mp->msg))
#line 475
		(
#line 475
	env_throw_bi(env, mfe_failure, "message_read_body_line", _("message not open"))
#line 475
)
#line 475

#line 475
;
#line 475
	if (!mp->body) {
#line 475
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 475
			if (!(rc == 0))
#line 475
		(
#line 475
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 475
)
#line 475
;
#line 475
	}	  
#line 475
;
	
	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 479
		(
#line 479
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 479
)
#line 482
;
	}
	rc = mu_stream_getline(mp->bstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 485
		(
#line 485
	env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 485
)
#line 488
;
		if (!(size > 0))
#line 489
		(
#line 489
	env_throw_bi(env, mfe_eof, "message_read_body_line", "mu_stream_getline: %s",_("end of input"))
#line 489
)
#line 492
;
	do {pushs(env, mp->buf);
#line 493
goto endlab;
#line 493
} while (0);
}
endlab:
#line 495
	return;
#line 495
}


#line 497
void
#line 497
msg_init_builtin()
#line 497
{
#line 497
	
#line 497
	#line 57 "msg.bi"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs,
#line 57
drop_current_message);
#line 166 "msg.bi"
va_builtin_install_ex("message_close", bi_message_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 174 "msg.bi"
va_builtin_install_ex("message_size", bi_message_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 192 "msg.bi"
va_builtin_install_ex("message_lines", bi_message_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 208 "msg.bi"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 226 "msg.bi"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 245 "msg.bi"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 263 "msg.bi"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 279 "msg.bi"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 310 "msg.bi"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, dtype_number, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 323 "msg.bi"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, dtype_string, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 340 "msg.bi"
va_builtin_install_ex("message_nth_header_name", bi_message_nth_header_name, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 356 "msg.bi"
va_builtin_install_ex("message_nth_header_value", bi_message_nth_header_value, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 375 "msg.bi"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 390 "msg.bi"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 405 "msg.bi"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 428 "msg.bi"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 436 "msg.bi"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 463 "msg.bi"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 471 "msg.bi"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, dtype_string, 1, 0, 0|0, dtype_number);

#line 497 "msg.bi"
	
#line 497
	 mf_add_runtime_params(msg_cfg_param);
#line 497
	 
#line 497
}
#line 497 "msg.bi"

#line 499

#line 736 "../../src/builtin/snarf.m4"

#line 736

