/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 138
#ifdef HAVE_CONFIG_H
#line 138
# include <config.h>
#line 138
#endif
#line 138
#include <sys/types.h>
#line 138

#line 138
#include "mailfromd.h"
#line 138
#include "prog.h"
#line 138
#include "builtin.h"
#line 138

#line 138

#line 742 "../../src/builtin/snarf.m4"

#line 1 "sieve.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2007, 2008, 2009, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <mailutils/mailutils.h>
#include <mflib/sieve.h>

static void
_sieve_text_action_log(void *env_ptr,
		       mu_stream_t stream, size_t msgno,
		       mu_message_t msg,
		       const char *action, const char *fmt, va_list ap)
{
	eval_environ_t env = env_ptr;
	const char *id;
	
	mu_stream_printf(stream, "\033s<%d>", MU_LOG_NOTICE);
	id = mailfromd_msgid(env_get_context(env));
	if (id && id[0])
		/* ID includes trailing semicolon */
		mu_stream_printf(stream, "%s", id);
	mu_stream_printf(stream, "%s", action);
	if (fmt && fmt[0]) {
		mu_stream_printf(stream, "; ");
		mu_stream_vprintf(stream, fmt, ap);
	}
	mu_stream_printf(stream, "\n");
}

static void
_sieve_file_action_log(void *env_ptr,
		       mu_stream_t stream, size_t msgno,
		       mu_message_t msg,
		       const char *action, const char *fmt, va_list ap)
{
	eval_environ_t env = env_ptr;
	struct locus locus;

	_sieve_text_action_log(env_ptr, stream, msgno, msg, action, fmt, ap);

	env_get_locus(env, &locus);
	mu_stream_printf(stream, "\033f<%d>%s\033l<%lu>\033s<%d>\033O<%d>%s\n",
			 strlen(locus.file), locus.file, locus.line,
			 MU_LOG_NOTICE,
		         MU_LOGMODE_LOCUS|MU_LOGMODE_SEVERITY,
			 _("sieve called from here"));
}


	
void
#line 63
bi_sieve(eval_environ_t env)
#line 63

#line 63

#line 63 "sieve.bi"
{
#line 63
	  mu_stream_t mstr;
#line 63

#line 63
	
#line 63

#line 63
long __bi_argcnt;
#line 63
char *  script;
#line 63
        long  flags;
#line 63
        char *  file;
#line 63
        long  line;
#line 63
        
#line 63
get_string_arg(env, 1, &script);
#line 63
        get_numeric_arg(env, 2, &flags);
#line 63
        get_string_arg(env, 3, &file);
#line 63
        get_numeric_arg(env, 4, &line);
#line 63
        
#line 63
get_numeric_arg(env, 0, &__bi_argcnt);
#line 63
        adjust_stack(env, __bi_argcnt + 1);
#line 63

#line 63
{
#line 63
	  int rc = env_get_stream(env,&mstr);
#line 63
	  	if (!(rc == 0))
#line 63
		(
#line 63

#line 63
	mu_stream_unref(mstr),
#line 63
	env_throw_bi(env, mfe_failure, "sieve", "cannot obtain capture stream reference: %s",mu_strerror(rc))
#line 63
)
#line 63
;
#line 63
	}
#line 63
	if (builtin_module_trace(BUILTIN_IDX_sieve))
#line 63
		prog_trace(env, "sieve %s %lu %s %lu",script, ((__bi_argcnt > 1) ? flags : 0), ((__bi_argcnt > 2) ? file : ""), ((__bi_argcnt > 3) ? line : 0));;

{
	mu_sieve_machine_t mach;
	int sieve_debug_flags = 0;
	int rc;
	int retval = 0;
	int f = ((__bi_argcnt > 1) ? flags : 0);

	rc = mu_sieve_machine_init(&mach);
		if (!(rc == 0))
#line 73
		(
#line 73

#line 73
	mu_stream_unref(mstr),
#line 73
	env_throw_bi(env, mfe_failure, "sieve", _("failed to initialize sieve machine: %s"),mu_strerror(rc))
#line 73
)
#line 75
;

	if (f & MF_SIEVE_DEBUG_TRACE)
		sieve_debug_flags |= MU_SIEVE_DEBUG_TRACE;
	if (f & MF_SIEVE_DEBUG_INSTR)
		sieve_debug_flags |= MU_SIEVE_DEBUG_INSTR;

	mu_sieve_set_debug_level(mach, sieve_debug_flags);

	mu_sieve_set_data(mach, env);

	if (f & MF_SIEVE_TEXT) {
		struct locus locus;

		env_get_locus(env, &locus);
		if (f & MF_SIEVE_LOG)
			mu_sieve_set_logger(mach, _sieve_text_action_log);
		rc = mu_sieve_compile_buffer(mach, script, strlen(script),
					     ((__bi_argcnt > 2) ? file : locus.file),
					     ((__bi_argcnt > 3) ? line : locus.line));
	} else {
		if (f & MF_SIEVE_LOG)
			mu_sieve_set_logger(mach, _sieve_file_action_log);
		rc = mu_sieve_compile(mach, script);
	}
	if (rc == 0) {
		mu_attribute_t attr;
		mu_message_t msg;

		rc = mu_stream_to_message(mstr, &msg);
		if (rc) {
			mu_sieve_machine_destroy(&mach);
			(
#line 107

#line 107
	mu_stream_unref(mstr),
#line 107
	env_throw_bi(env, mfe_failure, "sieve", _("cannot translate stream to message: %s"),mu_strerror (rc))
#line 107
);
#line 110
		}
		
		mu_message_get_attribute(msg, &attr);
		mu_attribute_unset_deleted(attr);
		rc = mu_sieve_message(mach, msg);
		if (rc == 0)
			retval = !(mu_attribute_is_deleted(attr) == 0);
		/* Destroy the message.  This also indirectly unrefs the mstr,
		   bringing its refcount back to its initial value. */
		mu_message_destroy(&msg, mu_message_get_owner(msg));
		if (rc) {
			mu_sieve_machine_destroy(&mach);
			(
#line 122

#line 122
	mu_stream_unref(mstr),
#line 122
	env_throw_bi(env, mfe_failure, "sieve", _("sieving failed: %s"),mu_strerror(rc))
#line 122
);
#line 125
		}
	} else {
		(
#line 127

#line 127
	mu_stream_unref(mstr),
#line 127
	env_throw_bi(env, mfe_failure, "sieve", _("compilation of Sieve script %s failed"),script)
#line 127
);
#line 130
	}
	
	mu_sieve_machine_destroy(&mach);

	
#line 134
do {
#line 134
  push(env, (STKVAL) (retval));
#line 134
  goto endlab;
#line 134
} while (0);
}
endlab:
#line 136

#line 136
	mu_stream_unref(mstr);
#line 136
	return;
#line 136
}


#line 138
void
#line 138
sieve_init_builtin()
#line 138
{
#line 138
	
#line 138
	#line 63 "sieve.bi"
va_builtin_install_ex("sieve", bi_sieve, STATMASK(smtp_state_eom), dtype_number, 4, 3, MFD_BUILTIN_CAPTURE|0, dtype_string, dtype_number, dtype_string, dtype_number);

#line 138 "sieve.bi"
	
#line 138
}
#line 138 "sieve.bi"

#line 138

#line 736 "../../src/builtin/snarf.m4"

#line 736

